//include a function
#include <RcppArmadillo.h>

using namespace Rcpp;
// calculation of a dot product
double dotp (arma::mat x,arma::mat y);
// calculation of the entropy
double Entropy(arma::mat x);

// Functions regarding the chosen loss

// L2-loss
arma::mat f_one_L2(arma::mat a);
arma::mat f_two_L2(arma::mat b);
arma::mat h_one_L2(arma::mat a);
arma::mat h_two_L2(arma::mat b);

// KL-loss
arma::mat f_one_KL(arma::mat a);
arma::mat f_two_KL(arma::mat b);
arma::mat h_one_KL(arma::mat a);
arma::mat h_two_KL(arma::mat b);

// Debugging helper

void showMatrix(arma::mat X);
void showVector(arma::vec X);
